package de.jpv.accessors;

import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiMethod;
import com.intellij.psi.PsiReferenceExpression;
import com.intellij.psi.PsiClass;

public class AccessorContext {

  public enum Type {
    GETTER, SETTER;
  }

  private PsiReferenceExpression reference;
  private PsiClass psiClass;
  private Type accessorType;
  private PsiMethod getterMethod;
  private PsiMethod setterMethod;

  public AccessorContext(PsiReferenceExpression reference, PsiClass psiClass,
                         Type accessorType,
                         PsiMethod getterMethod, PsiMethod setterMethod) {
    this.reference = reference;
    this.psiClass = psiClass;
    this.accessorType = accessorType;
    this.getterMethod = getterMethod;
    this.setterMethod = setterMethod;
  }

  public PsiReferenceExpression getReference() {
    return reference;
  }

  public PsiClass getPsiClass() {
    return psiClass;
  }

  public Type getAccessorType() {
    return accessorType;
  }

  public PsiMethod getGetterMethod() {
    return getterMethod;
  }

  public void setGetterMethod(PsiMethod getterMethod) {
    this.getterMethod = getterMethod;
  }

  public PsiMethod getSetterMethod() {
    return setterMethod;
  }

  public void setSetterMethod(PsiMethod setterMethod) {
    this.setterMethod = setterMethod;
  }

}
